import {IJsonCourse} from "./types"
import {JsonCourseList} from "./poll"
import {findJsonCourse} from "./includes"
import {appConfig} from "./config"

let lastJsonCourseList: { bx: IJsonCourse[], xx: IJsonCourse[], rx: IJsonCourse[] }
let firstRunHealth = true

export async function health() {
    let totalAcquireCount = 0
    let totalExitCount = 0
    if (firstRunHealth) {
        console.log('[health]程序health监控启动完毕')
        firstRunHealth = false
    } else {
        for (let channel of appConfig.channels) {
            for (let lastCourse of lastJsonCourseList[channel]) {
                let currentCourse = findJsonCourse({
                    kch: lastCourse.kch,
                    kxh: parseInt(lastCourse.kxh),
                    channel: channel
                })
                if (currentCourse == undefined) {
                    continue
                }
                if (parseInt(currentCourse.syrs) > parseInt(lastCourse.syrs)) {
                    totalExitCount += parseInt(currentCourse.syrs) - parseInt(lastCourse.syrs)
                } else {
                    totalAcquireCount += parseInt(lastCourse.syrs) - parseInt(currentCourse.syrs)
                }
            }
        }
        console.log('[health]实时总退课人次：' + totalExitCount + '，总选课人次：' + totalAcquireCount)
    }
    lastJsonCourseList = JSON.parse(JSON.stringify(JsonCourseList))
    setTimeout(health, 60 * 1000)
}
